/* Disper Displays Extension
 * author: mark bokil
 * 8/25/12
 * version 1.0
 * some code also by Panel Commands by Denoyse <denoyse@gmail.com>.
 * Thanks to gcampax (https://extensions.gnome.org/accounts/profile/gcampax) for most of the code ;-)
 */


const GLib = imports.gi.GLib;
const Main = imports.ui.main;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;
const Gettext = imports.gettext.domain('gnome-shell-extensions');
const _ = Gettext.gettext;

function Indicator() {
    this._init.apply(this, arguments);
}

Indicator.prototype = {
    __proto__: PanelMenu.SystemStatusButton.prototype,

    _init: function() {
        PanelMenu.SystemStatusButton.prototype._init.call(this, 'video-display-symbolic'); 
        this._createMenu();
    },

    _createMenu: function() {
        this._addCommand("Primary Display", "disper --single");
        this._addCommand("Secondary Display", "disper --secondary");
        this._addCommand("Extend Displays", "disper --extend");
        this._addCommand("Clone Displays", "disper --clone");
    },


    _addSeparator: function() {
	    // Make a separator.
    	this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
    },

    _addBoldText: function(text) {
    	// Insert a bold text.
    	let item = new PopupMenu.PopupMenuItem(_(text));
        item.label.add_style_class_name('bold-text');
        item.actor.reactive = false;
        item.actor.can_focus = false;
        this.menu.addMenuItem(item);
    },

    _addCommand: function(label, command) {
    	// Insert a starter.
    	this.menu.addAction(_(label), function() { 
            try {
                GLib.spawn_command_line_async(command);
            } catch(e) {
            GLib.spawn_command_line_async("notify-send 'This extension requires Disper to be installed.'");
            }
        });
    },
}


function init() {}

let _indicator;

function enable() {
    _indicator = new Indicator();
    Main.panel.addToStatusArea('display', _indicator);
}

function disable() {
    _indicator.destroy();
}
